{-# LANGUAGE EmptyDataDecls, RankNTypes, ScopedTypeVariables #-}

module
  GPV(Sum, Generat, Pmf, Gpv, bind_gpv, inline, exec_gpv, lift_spmf, map_gpv)
  where {

import Prelude ((==), (/=), (<), (<=), (>=), (>), (+), (-), (*), (/), (**),
  (>>=), (>>), (=<<), (&&), (||), (^), (^^), (.), ($), ($!), (++), (!!), Eq,
  error, id, return, not, fst, snd, map, filter, concat, concatMap, reverse,
  zip, null, takeWhile, dropWhile, all, any, Integer, negate, abs, divMod,
  String, Bool(True, False), Maybe(Nothing, Just));
import qualified Prelude;

data Num = One | Bit0 Num | Bit1 Num;

equal_num :: Num -> Num -> Bool;
equal_num (Bit0 x2) (Bit1 x3) = False;
equal_num (Bit1 x3) (Bit0 x2) = False;
equal_num One (Bit1 x3) = False;
equal_num (Bit1 x3) One = False;
equal_num One (Bit0 x2) = False;
equal_num (Bit0 x2) One = False;
equal_num (Bit1 x3) (Bit1 y3) = equal_num x3 y3;
equal_num (Bit0 x2) (Bit0 y2) = equal_num x2 y2;
equal_num One One = True;

data Int = Zero_int | Pos Num | Neg Num;

equal_int :: Int -> Int -> Bool;
equal_int (Neg k) (Neg l) = equal_num k l;
equal_int (Neg k) (Pos l) = False;
equal_int (Neg k) Zero_int = False;
equal_int (Pos k) (Neg l) = False;
equal_int (Pos k) (Pos l) = equal_num k l;
equal_int (Pos k) Zero_int = False;
equal_int Zero_int (Neg l) = False;
equal_int Zero_int (Pos l) = False;
equal_int Zero_int Zero_int = True;

instance Eq Int where {
  a == b = equal_int a b;
};

one_int :: Int;
one_int = Pos One;

class One a where {
  one :: a;
};

instance One Int where {
  one = one_int;
};

class Zero a where {
  zero :: a;
};

instance Zero Int where {
  zero = Zero_int;
};

class (One a, Zero a) => Zero_neq_one a where {
};

instance Zero_neq_one Int where {
};

newtype Rat = Frct (Int, Int);

newtype Real = Ratreal Rat;

data Sum a b = Inl a | Inr b;

data Generat a b c = Pure a | IO b c;

newtype Nnreal = Nnreal Real;

newtype Pmf_impl a = Pmf_impl_of_pfp [(a, Nnreal)];

newtype Pmf a = Abs_pmf (Pmf_impl a);

newtype Gpv a b c = GPV (Pmf (Maybe (Generat a b (c -> Gpv a b c))));

dup :: Int -> Int;
dup (Neg n) = Neg (Bit0 n);
dup (Pos n) = Pos (Bit0 n);
dup Zero_int = Zero_int;

uminus_int :: Int -> Int;
uminus_int (Neg m) = Pos m;
uminus_int (Pos m) = Neg m;
uminus_int Zero_int = Zero_int;

plus_num :: Num -> Num -> Num;
plus_num (Bit1 m) (Bit1 n) = Bit0 (plus_num (plus_num m n) One);
plus_num (Bit1 m) (Bit0 n) = Bit1 (plus_num m n);
plus_num (Bit1 m) One = Bit0 (plus_num m One);
plus_num (Bit0 m) (Bit1 n) = Bit1 (plus_num m n);
plus_num (Bit0 m) (Bit0 n) = Bit0 (plus_num m n);
plus_num (Bit0 m) One = Bit1 m;
plus_num One (Bit1 n) = Bit0 (plus_num n One);
plus_num One (Bit0 n) = Bit1 n;
plus_num One One = Bit0 One;

bitM :: Num -> Num;
bitM One = One;
bitM (Bit0 n) = Bit1 (bitM n);
bitM (Bit1 n) = Bit1 (Bit0 n);

sub :: Num -> Num -> Int;
sub (Bit0 m) (Bit1 n) = minus_int (dup (sub m n)) (Pos One);
sub (Bit1 m) (Bit0 n) = plus_int (dup (sub m n)) (Pos One);
sub (Bit1 m) (Bit1 n) = dup (sub m n);
sub (Bit0 m) (Bit0 n) = dup (sub m n);
sub One (Bit1 n) = Neg (Bit0 n);
sub One (Bit0 n) = Neg (bitM n);
sub (Bit1 m) One = Pos (Bit0 m);
sub (Bit0 m) One = Pos (bitM m);
sub One One = Zero_int;

plus_int :: Int -> Int -> Int;
plus_int (Neg m) (Neg n) = Neg (plus_num m n);
plus_int (Neg m) (Pos n) = sub n m;
plus_int (Pos m) (Neg n) = sub m n;
plus_int (Pos m) (Pos n) = Pos (plus_num m n);
plus_int Zero_int l = l;
plus_int k Zero_int = k;

minus_int :: Int -> Int -> Int;
minus_int (Neg m) (Neg n) = sub n m;
minus_int (Neg m) (Pos n) = Neg (plus_num m n);
minus_int (Pos m) (Neg n) = Pos (plus_num m n);
minus_int (Pos m) (Pos n) = sub m n;
minus_int Zero_int l = uminus_int l;
minus_int k Zero_int = k;

foldr :: forall a b. (a -> b -> b) -> [a] -> b -> b;
foldr f [] = id;
foldr f (x : xs) = f x . foldr f xs;

times_num :: Num -> Num -> Num;
times_num (Bit1 m) (Bit1 n) =
  Bit1 (plus_num (plus_num m n) (Bit0 (times_num m n)));
times_num (Bit1 m) (Bit0 n) = Bit0 (times_num (Bit1 m) n);
times_num (Bit0 m) (Bit1 n) = Bit0 (times_num m (Bit1 n));
times_num (Bit0 m) (Bit0 n) = Bit0 (Bit0 (times_num m n));
times_num One n = n;
times_num m One = m;

times_int :: Int -> Int -> Int;
times_int (Neg m) (Neg n) = Pos (times_num m n);
times_int (Neg m) (Pos n) = Neg (times_num m n);
times_int (Pos m) (Neg n) = Neg (times_num m n);
times_int (Pos m) (Pos n) = Pos (times_num m n);
times_int Zero_int l = Zero_int;
times_int k Zero_int = Zero_int;

less_eq_num :: Num -> Num -> Bool;
less_eq_num (Bit1 m) (Bit0 n) = less_num m n;
less_eq_num (Bit1 m) (Bit1 n) = less_eq_num m n;
less_eq_num (Bit0 m) (Bit1 n) = less_eq_num m n;
less_eq_num (Bit0 m) (Bit0 n) = less_eq_num m n;
less_eq_num (Bit1 m) One = False;
less_eq_num (Bit0 m) One = False;
less_eq_num One n = True;

less_num :: Num -> Num -> Bool;
less_num (Bit1 m) (Bit0 n) = less_num m n;
less_num (Bit1 m) (Bit1 n) = less_num m n;
less_num (Bit0 m) (Bit1 n) = less_eq_num m n;
less_num (Bit0 m) (Bit0 n) = less_num m n;
less_num One (Bit1 n) = True;
less_num One (Bit0 n) = True;
less_num m One = False;

less_eq_int :: Int -> Int -> Bool;
less_eq_int (Neg k) (Neg l) = less_eq_num l k;
less_eq_int (Neg k) (Pos l) = True;
less_eq_int (Neg k) Zero_int = True;
less_eq_int (Pos k) (Neg l) = False;
less_eq_int (Pos k) (Pos l) = less_eq_num k l;
less_eq_int (Pos k) Zero_int = False;
less_eq_int Zero_int (Neg l) = False;
less_eq_int Zero_int (Pos l) = True;
less_eq_int Zero_int Zero_int = True;

divmod_step_int :: Num -> (Int, Int) -> (Int, Int);
divmod_step_int l (q, r) =
  (if less_eq_int (Pos l) r
    then (plus_int (times_int (Pos (Bit0 One)) q) (Pos One),
           minus_int r (Pos l))
    else (times_int (Pos (Bit0 One)) q, r));

divmod_int :: Num -> Num -> (Int, Int);
divmod_int (Bit1 m) (Bit1 n) =
  (if less_num m n then (Zero_int, Pos (Bit1 m))
    else divmod_step_int (Bit1 n) (divmod_int (Bit1 m) (Bit0 (Bit1 n))));
divmod_int (Bit0 m) (Bit1 n) =
  (if less_eq_num m n then (Zero_int, Pos (Bit0 m))
    else divmod_step_int (Bit1 n) (divmod_int (Bit0 m) (Bit0 (Bit1 n))));
divmod_int (Bit1 m) (Bit0 n) =
  let {
    (q, r) = divmod_int m n;
  } in (q, plus_int (times_int (Pos (Bit0 One)) r) (Pos One));
divmod_int (Bit0 m) (Bit0 n) = let {
                                 (q, r) = divmod_int m n;
                               } in (q, times_int (Pos (Bit0 One)) r);
divmod_int One (Bit1 n) = (Zero_int, Pos One);
divmod_int One (Bit0 n) = (Zero_int, Pos One);
divmod_int (Bit1 m) One = (Pos (Bit1 m), Zero_int);
divmod_int (Bit0 m) One = (Pos (Bit0 m), Zero_int);
divmod_int One One = (Pos One, Zero_int);

of_bool :: forall a. (Zero_neq_one a) => Bool -> a;
of_bool True = one;
of_bool False = zero;

adjust_div :: (Int, Int) -> Int;
adjust_div (q, r) = plus_int q (of_bool (not (equal_int r Zero_int)));

divide_int :: Int -> Int -> Int;
divide_int (Neg m) (Neg n) = fst (divmod_int m n);
divide_int (Pos m) (Neg n) = uminus_int (adjust_div (divmod_int m n));
divide_int (Neg m) (Pos n) = uminus_int (adjust_div (divmod_int m n));
divide_int (Pos m) (Pos n) = fst (divmod_int m n);
divide_int k (Neg One) = uminus_int k;
divide_int k (Pos One) = k;
divide_int Zero_int k = Zero_int;
divide_int k Zero_int = Zero_int;

less_int :: Int -> Int -> Bool;
less_int (Neg k) (Neg l) = less_num l k;
less_int (Neg k) (Pos l) = True;
less_int (Neg k) Zero_int = True;
less_int (Pos k) (Neg l) = False;
less_int (Pos k) (Pos l) = less_num k l;
less_int (Pos k) Zero_int = False;
less_int Zero_int (Neg l) = False;
less_int Zero_int (Pos l) = True;
less_int Zero_int Zero_int = False;

adjust_mod :: Int -> Int -> Int;
adjust_mod l r = (if equal_int r Zero_int then Zero_int else minus_int l r);

modulo_int :: Int -> Int -> Int;
modulo_int (Neg m) (Neg n) = uminus_int (snd (divmod_int m n));
modulo_int (Pos m) (Neg n) =
  uminus_int (adjust_mod (Pos n) (snd (divmod_int m n)));
modulo_int (Neg m) (Pos n) = adjust_mod (Pos n) (snd (divmod_int m n));
modulo_int (Pos m) (Pos n) = snd (divmod_int m n);
modulo_int k (Neg One) = Zero_int;
modulo_int k (Pos One) = Zero_int;
modulo_int Zero_int k = Zero_int;
modulo_int k Zero_int = k;

abs_int :: Int -> Int;
abs_int i = (if less_int i Zero_int then uminus_int i else i);

gcd_int :: Int -> Int -> Int;
gcd_int k l =
  abs_int
    (if equal_int l Zero_int then k
      else gcd_int l (modulo_int (abs_int k) (abs_int l)));

normalize :: (Int, Int) -> (Int, Int);
normalize p =
  (if less_int Zero_int (snd p)
    then let {
           a = gcd_int (fst p) (snd p);
         } in (divide_int (fst p) a, divide_int (snd p) a)
    else (if equal_int (snd p) Zero_int then (Zero_int, Pos One)
           else let {
                  a = uminus_int (gcd_int (fst p) (snd p));
                } in (divide_int (fst p) a, divide_int (snd p) a)));

one_rat :: Rat;
one_rat = Frct (Pos One, Pos One);

one_nnreal :: Nnreal;
one_nnreal = Nnreal (Ratreal one_rat);

return_pmf_impl :: forall a. a -> Pmf_impl a;
return_pmf_impl x = Pmf_impl_of_pfp [(x, one_nnreal)];

return_pmf :: forall a. a -> Pmf a;
return_pmf x = Abs_pmf (return_pmf_impl x);

quotient_of :: Rat -> (Int, Int);
quotient_of (Frct x) = x;

times_rat :: Rat -> Rat -> Rat;
times_rat p q = Frct (let {
                        a = quotient_of p;
                        (aa, c) = a;
                        b = quotient_of q;
                        (ba, d) = b;
                      } in normalize (times_int aa ba, times_int c d));

times_real :: Real -> Real -> Real;
times_real (Ratreal x) (Ratreal y) = Ratreal (times_rat x y);

real_of_nnreal :: Nnreal -> Real;
real_of_nnreal (Nnreal x) = x;

times_nnreal :: Nnreal -> Nnreal -> Nnreal;
times_nnreal xb xc =
  Nnreal (times_real (real_of_nnreal xb) (real_of_nnreal xc));

equal_rat :: Rat -> Rat -> Bool;
equal_rat a b = quotient_of a == quotient_of b;

equal_real :: Real -> Real -> Bool;
equal_real (Ratreal x) (Ratreal y) = equal_rat x y;

equal_nnreal :: Nnreal -> Nnreal -> Bool;
equal_nnreal xa xc = equal_real (real_of_nnreal xa) (real_of_nnreal xc);

zero_rat :: Rat;
zero_rat = Frct (Zero_int, Pos One);

zero_nnreal :: Nnreal;
zero_nnreal = Nnreal (Ratreal zero_rat);

apsnd :: forall a b c. (a -> b) -> (c, a) -> (c, b);
apsnd f (x, y) = (x, f y);

scale_pmf_impl :: forall a. Nnreal -> Pmf_impl a -> Pmf_impl a;
scale_pmf_impl p (Pmf_impl_of_pfp xs) =
  Pmf_impl_of_pfp
    (if equal_nnreal p zero_nnreal then []
      else map (apsnd (times_nnreal p)) xs);

zero_pmf_impl :: forall a. Pmf_impl a;
zero_pmf_impl = Pmf_impl_of_pfp [];

plus_pmf_impl :: forall a. Pmf_impl a -> Pmf_impl a -> Pmf_impl a;
plus_pmf_impl (Pmf_impl_of_pfp xs) (Pmf_impl_of_pfp ys) =
  Pmf_impl_of_pfp (xs ++ ys);

bind_pmf_impl :: forall a b. Pmf_impl a -> (a -> Pmf_impl b) -> Pmf_impl b;
bind_pmf_impl (Pmf_impl_of_pfp xs) f =
  foldr (\ (x, p) -> plus_pmf_impl (scale_pmf_impl p (f x))) xs zero_pmf_impl;

rep_pmf :: forall a. Pmf a -> Pmf_impl a;
rep_pmf (Abs_pmf x) = x;

bind_pmf :: forall b a. Pmf b -> (b -> Pmf a) -> Pmf a;
bind_pmf p f = Abs_pmf (bind_pmf_impl (rep_pmf p) (\ x -> rep_pmf (f x)));

bind_spmf :: forall a b. Pmf (Maybe a) -> (a -> Pmf (Maybe b)) -> Pmf (Maybe b);
bind_spmf x f = bind_pmf x (\ a -> (case a of {
                                     Nothing -> return_pmf Nothing;
                                     Just aa -> f aa;
                                   }));

apfst :: forall a b c. (a -> b) -> (a, c) -> (b, c);
apfst f (x, y) = (f x, y);

map_pmf_impl :: forall a b. (a -> b) -> Pmf_impl a -> Pmf_impl b;
map_pmf_impl f (Pmf_impl_of_pfp xs) = Pmf_impl_of_pfp (map (apfst f) xs);

map_option :: forall a b. (a -> b) -> Maybe a -> Maybe b;
map_option f Nothing = Nothing;
map_option f (Just x2) = Just (f x2);

map_generat ::
  forall a b c d e f.
    (a -> b) -> (c -> d) -> (e -> f) -> Generat a c e -> Generat b d f;
map_generat f1 f2 f3 (Pure x1) = Pure (f1 x1);
map_generat f1 f2 f3 (IO x21 x22) = IO (f2 x21) (f3 x22);

map_pmf :: forall b a. (b -> a) -> Pmf b -> Pmf a;
map_pmf f p = Abs_pmf (map_pmf_impl f (rep_pmf p));

the_gpv ::
  forall a b c. Gpv a b c -> Pmf (Maybe (Generat a b (c -> Gpv a b c)));
the_gpv (GPV x) = x;

bind_gpv :: forall a b c d. Gpv a b c -> (a -> Gpv d b c) -> Gpv d b c;
bind_gpv r f =
  GPV (bind_spmf (the_gpv r)
        (\ a ->
          (case a of {
            Pure x -> the_gpv (f x);
            IO out c ->
              return_pmf (Just (IO out (\ input -> bind_gpv (c input) f)));
          })));

inline1 ::
  forall a b c d e f.
    (a -> b -> Gpv (c, a) d e) ->
      Gpv f b c ->
        a -> Pmf (Maybe (Sum (f, a)
                          (d, (e -> Gpv (c, a) d e, c -> Gpv f b c))));
inline1 callee gpv s =
  bind_spmf (the_gpv gpv)
    (\ a ->
      (case a of {
        Pure x -> return_pmf (Just (Inl (x, s)));
        IO out rpv ->
          bind_spmf (the_gpv (callee s out))
            (\ aa ->
              (case aa of {
                Pure ab -> let {
                             (x, ac) = ab;
                           } in inline1 callee (rpv x) ac;
                IO outa rpva -> return_pmf (Just (Inr (outa, (rpva, rpv))));
              }));
      }));

inline ::
  forall a b c d e f.
    (a -> b -> Gpv (c, a) d e) -> Gpv f b c -> a -> Gpv (f, a) d e;
inline oracle gpv s =
  GPV (map_pmf
        (map_option
          (\ a ->
            (case a of {
              Inl aa -> Pure aa;
              Inr (out, (oraclea, rpv)) ->
                IO out
                  (\ input ->
                    bind_gpv (oraclea input)
                      (\ (x, aa) -> inline oracle (rpv x) aa));
            })))
        (inline1 oracle gpv s));

exec_gpv ::
  forall a b c d.
    (a -> b -> Pmf (Maybe (c, a))) -> Gpv d b c -> a -> Pmf (Maybe (d, a));
exec_gpv callee c s =
  bind_spmf (the_gpv c)
    (\ a ->
      (case a of {
        Pure x -> return_pmf (Just (x, s));
        IO out ca ->
          bind_spmf (callee s out) (\ (x, aa) -> exec_gpv callee (ca x) aa);
      }));

lift_spmf :: forall a b c. Pmf (Maybe a) -> Gpv a b c;
lift_spmf p = GPV (map_pmf (map_option Pure) p);

map_gpv :: forall a b c d e. (a -> b) -> (c -> d) -> Gpv a c e -> Gpv b d e;
map_gpv f1 f2 (GPV x) =
  GPV (map_pmf (map_option (map_generat f1 f2 (\ a -> map_gpv f1 f2 . a))) x);

}
